<?php
// $Id: hotel_booking.panes.inc,v 1.1.2.1 2010/07/02 09:40:01 larowlan Exp $
/*
 * @file hotel_booking.panes.inc
 * Provides cart, checkout and order panes for Ubercart
 * @copyright Copyright(c) 2010 Lee Rowlands
 * @license GPL v2 http://www.fsf.org/licensing/licenses/gpl.html
 * @author Lee Rowlands (larowlan) leerowlands at rowlands-bcs dot com
 * @author Will Vincent (tcindie) tcindie at gmail dot com
 * @todo - this whole file sucks ass
 *
 */


/**
 * Callbacks for order pane
 */
function hotel_booking_booking_pane($op, $order) {
  $proceed = FALSE;
  for ($i = 0; $i < count($order->products); $i++) {
    if ($order->products[$i]->data['module'] == 'hotel_booking') {
      //this is a hotel booking product
      $proceed = TRUE;
    }
  }
  switch ($op) {
    case 'view':
    case 'customer':
      if ($proceed) {
        return drupal_get_form('hotel_booking_details_pane_order', $order->products, $order->as_template);
      }
      else {
        break;
      }
  }
}

function hotel_booking_pane_rewards($op, $order) {
  switch ($op) {
    case 'view':
    case 'customer':
      if (!empty($order->reward_membership)) {
        $reward_number = $order->reward_membership;
        return t('Reward Membership Number: @reward', array('@reward' => $reward_number));
      }
      else {
        break;
      }
  }
}



/**
 * Functions to build fieldsets & tables for order pane
 * @param $form_state array std drupal FAPI form state var
 * @param $products array array of products as per $order->products
 * @param $as_template bool whether pane is being displayed in a template (ie printed invoice, emailed)
 *
 * @todo NOTE THAT travel_supplier module references this form
 */
function hotel_booking_details_pane_order($form_state, $products, $as_template) {
  foreach ($products as $product) {
    if ($product->data['module'] == 'hotel_booking') {
      $numnights[$product->order_product_id] = count($product->data['nights']);
    }
  }

  foreach ($products as $product) {
    if ($product->data['module'] == 'hotel_booking') {
      $title = check_plain($product->title);
      $title .= ' ('. count($product->data['nights']) .t(' Nights, ');
      $title .= format_plural($product->data['adults'], '1 Adult', '@count Adults');
      $title .= format_plural($product->data['children'], ', 1 Child', ', @count Children');
      $title .= ')';
      $foo = node_load($product->nid);
      $desc = (variable_get('hotel_booking_teaser_in_panes','FALSE')) ? '' : $foo->teaser;
      $desc .= '<div class="booking_details_blurb"><p>'. t('The following table breaks down your stay by day, listing price per night of the room');
      $desc .= ($product->data['booking_upgrades']) ? ', '. t('along with any applicable date based Add-On items.</p><p>Other Add-On items apply to your entire stay.') .'</p>' : '.</p>';
      $desc .= '</div>';
      $contents['booking_details'][$product->order_product_id] = array(
        '#type' => 'fieldset',
        '#title' => $title,
        '#description' => $desc,
        '#collapsible' => TRUE,
        // Default to collapsed if there are multiple room booking items in the cart,
        // or the booking has more than three nights and more than two addons, or if
        // the a single booking item has more than 5 nights.
        '#collapsed' => (sizeof($numnights) > 1 || (count($product->data['nights']) > 3 && sizeof($product->data['booking_upgrades']) > 2) || (count($product->data['nights']) > 5)) ? TRUE : FALSE,
      );
      $val = hotel_booking_order_details_table($product, $products, FALSE, $as_template);
      $contents['booking_details'][$product->order_product_id]['nid'] = array(
        '#value' => $val[0],
      );
      if ($val[1]) {
        $contents['booking_details'][$product->order_product_id]['nid']['additional'] = array(
          '#value' => hotel_booking_order_details_table($product, $products, TRUE, $as_template),
        );
      }
    }
  }
  return array('contents' => $contents);
}

/**
 * Utility, provides a table in the booking panes
 * @param $item object the product item
 * @param $products array all products in the cart
 * @param $additional bool whether the table is for additional items
 * @param $as_template bool whether the table is being displayed in an invoice template (printed/email)
 *                          and as such, needs to include style tags
*/
function hotel_booking_order_details_table(&$item, $products, $additional = FALSE, $as_template = FALSE) {
  $addons = $table_attributes = array();
  if ($as_template) {
    $table_attributes = array('width' => '100%', 'style' => 'font-family: verdana, arial, helvetica; font-size: small;');
  }
  if ($item->data['booking_upgrades_order']) {
    foreach ($item->data['booking_upgrades_order'] as $nid => $child_id) {
      for ($i = 0; $i < count($products); $i++) {
        if ($products[$i]->nid == $nid && $products[$i]->data['child_id'] == $child_id) {
          $addons[$products[$i]->nid]['order'] = $products[$i];
          $addons[$products[$i]->nid]['data'] = $products[$i]->data;
          $addons[$products[$i]->nid]['daily'] = ($addons[$products[$i]->nid]['data']['days']) ? TRUE : FALSE;
          if (!$additional_items) {
            $additional_items = (!$addons[$products[$i]->nid]['daily']) ? TRUE : FALSE;
          }
          if (!$daily_items) {
            $daily_items = ($addons[$products[$i]->nid]['daily']) ? TRUE : FALSE;
          }
        }
      }
    }
  }
  if (!$additional) {
    if ($addons && $daily_items) {
      $addon_title = t('Date Based Add-On Items');
      $qtys = t('Qty.');
    }
    $header = array(t('Dates'), array('data' => $addon_title, 'width' => '45%'), array('data' => t(''), 'colspan' => 2), $qtys, t('Total'));
    for ($i = 0; $i < sizeof($item->data['nights']); $i++) {
      $checkin = ($i == 0) ? t('Check-In') : '';
      $thisday = $item->data['nights'][$i];
      $foo = explode('-', $thisday);
      $today = date('l F j, Y', mktime(0, 0, 0, $foo[1], $foo[2], $foo[0]));
      $rows[] = array($today, '',  t('Night !night', array('!night' => ($i + 1))), $checkin, '', array('data' => '$'. $item->data['prices'][$i], 'class' => 'price'));
      foreach ($addons as $nid => $info) {
        if ($addons[$nid]['daily'] && $addons[$nid]['data']['days'][$thisday]) {
          $rows[] = array('', l($addons[$nid]['order']->title, 'booking_upgrades/'. $addons[$nid]['data']['parent_id']),'','',array('data' => $addons[$nid]['data']['days'][$thisday], 'class' => 'qty'), array('data' => '$' . number_format(($addons[$nid]['data']['days'][$thisday] * $addons[$nid]['order']->price), 2, '.', ','), 'class' => 'price'));
        }
      }
    }
    $thisday = date('Y-m-d', mktime(0, 0, 0, $foo[1], $foo[2]+1, $foo[0]));
    $today = date('l F j, Y', mktime(0, 0, 0, $foo[1], $foo[2]+1, $foo[0]));
    $rows[] = array($today, '', '', t('Check-Out'), '', '');
    foreach ($addons as $nid => $info) {
      if ($addons[$nid]['daily'] && $addons[$nid]['data']['days'][$thisday]) {
        $rows[] = array('', l($addons[$nid]['order']->title, 'booking_upgrades/'. $addons[$nid]['data']['parent_id']),'','',array('data' => $addons[$nid]['data']['days'][$thisday], 'class' => 'qty'), array('data' => '$' . number_format(($addons[$nid]['data']['days'][$thisday] * $addons[$nid]['order']->price), 2, '.', ','), 'class' => 'price'));
      }
    }

    $table = theme('table', $header, $rows, $table_attributes);
    if ($additional_items) {
    }
    return array($table, $additional_items);
  }
  else {
    $header = array(array('data' => t('Additional Add-On & Upgrade Items'), 'colspan' => 2, 'width' => '100%'), 'data' => t('Total'));
    foreach ($addons as $nid => $info) {
      if (!$addons[$nid]['daily']) {
        $rows[] = array($addons[$nid]['order']->qty .'x', array('data' => l($addons[$nid]['order']->title, 'booking_upgrades/'. $addons[$nid]['data']['parent_id']), 'width' => '100%'), array('data' => '$' . number_format(($addons[$nid]['order']->qty * $addons[$nid]['order']->price), 2, '.', ','), 'class' => 'price'));
      }
    }

    return theme('table', $header, $rows, $table_attributes);
  }
}


/**
 * Functions to build fieldsets & tables for cart pane
 */

function hotel_booking_details_pane_cart() {
  $items = uc_cart_get_contents();
  foreach ($items as $item) {
    if ($item->module == 'hotel_booking') {
      $numnights[$item->cart_item_id] = count($item->data['nights']);
    }
  }

  $contents['booking_details'] = array(
      '#type' => 'fieldset',
      '#title' => t('Booking Details'),
      '#description' => (sizeof($numnights) > 1) ? t('Click on the Room Types below to view your booking details.') : '',
      '#collapsible' => TRUE,
      '#collapsed'   => FALSE,
  );

  foreach ($items as $item) {
    if ($item->module == 'hotel_booking') {
      $title = t('@title', array('@title' => $item->title));
      $title .= ' ('. count($item->data['nights']);
      $title .= (count($item->data['nights']) > 1) ? t(' Nights, ') : t(' Night, ');
      $title .= ($item->data['adults'] > 1) ? $item->data['adults'] .t(' Adults') : $item->data['adults'] .t(' Adult');
      if ($item->data['children']) {
        $title .= ($item->data['children'] > 1) ? ', '. $item->data['children'] .t(' Children') : ', '. $item->data['children'] .t(' Child');
      }
      $title .= ')';
      $foo = node_load($item->nid);

      $desc = (variable_get('hotel_booking_teaser_in_panes','FALSE')) ? $foo->teaser : '';
      $desc .= '<div class="booking_details_blurb"><p>The following table breaks down your stay by day, listing price per night of the room';
      $desc .= ($item->data['booking_upgrades']) ? ', along with any applicable date based Add-On items.</p><p>Other Add-On items apply to your entire stay.</p>' : '.</p>';
      if (substr(drupal_get_destination(), -8, 8) != 'checkout') {
        $desc .= (is_array($item->data['booking_upgrades'])) ? '<p>'. l('Edit Addons & Upgrades', 'booking_upgrades/'. $item->cart_item_id) .'</p></div>' : '</div>';
      }
      else {
        $desc .= '</div>';
      }
      $contents['booking_details'][$item->cart_item_id] = array(
        '#type' => 'fieldset',
        '#title' => $title,
        '#description' => $desc,
        '#collapsible' => TRUE,
        // Default to collapsed if there are multiple room booking items in the cart,
        // or the booking has more than three nights and more than two addons, or if
        // the a single booking item has more than 5 nights.
        '#collapsed' => (sizeof($numnights) > 1 || ($numnights[$item->cart_item_id] > 3 && sizeof($item->data['booking_upgrades']) > 2) || ($numnights[$item->cart_item_id] > 5)) ? TRUE : FALSE,
      );
      $val = hotel_booking_cart_details_table($item);
      $contents['booking_details'][$item->cart_item_id]['nid'] = array(
        '#value' => $val[0],
      );
      if ($val[1]) {
        $contents['booking_details'][$item->cart_item_id]['nid']['additional'] = array(
          '#value' => hotel_booking_cart_details_table($item, TRUE),
        );
      }
    }
  }
  return array('contents' => $contents);
}



/**
 * Callbacks for checkout pane
 */
function hotel_booking_rewards($op, &$order, $newvalue) {
  switch ($op) {
    case 'view':
      $description = t('If you have a reward membership card, please enter the number here.');
      $contents['reward_membership'] = array(
        '#type'          => 'textfield',
        '#title'         => variable_get('hotel_booking_reward_prompt', ''),
        '#default_value' => ($order->reward_membership) ? $order->reward_membership : '',
      );
      return array('description' => $description, 'contents' => $contents);
    case 'process':
      $order->reward_membership = $newvalue['reward_membership'];
      return TRUE;
    case 'review':
      $review = ($order->reward_membership) ? $order->reward_membership : NULL;
      return $review;
  }
}

function hotel_booking_details_pane_checkout($op, &$order, $arg2) {
  switch ($op) {
    case 'view':
      $contents = array();

      $items = uc_cart_get_contents();
      foreach ($items as $item) {
        if ($item->module == 'hotel_booking') {
          $numnights[$item->cart_item_id] = count($item->data['nights']);
        }
      }

      foreach ($items as $item) {
        if ($item->module == 'hotel_booking') {
          $title = check_plain($item->title);
          $title .= ' ('. count($item->data['nights']) .t(' Nights, ');
          $title .= format_plural($item->data['adults'], '1 Adult', '@count Adults');
          $title .= format_plural($item->data['children'], ', 1 Child', ', @count Children');
          $title .= ')';
          $foo = node_load($item->nid);

          $desc = (variable_get('hotel_booking_teaser_in_panes','FALSE')) ? $foo->teaser : '';
          $desc .= '<div class="booking_details_blurb"><p>The following table breaks down your stay by day, listing price per night of the room';
          $desc .= ($item->data['booking_upgrades']) ? ', along with any applicable date based Add-On items.</p><p>Other Add-On items apply to your entire stay.</p>' : '.</p>';
          if (substr(drupal_get_destination(), -8, 8) != 'checkout') {
            $desc .= (is_array($item->data['booking_upgrades'])) ? '<p>'. l('Edit Addons & Upgrades', 'booking_upgrades/'. $item->cart_item_id) .'</p></div>' : '</div>';
          }
          else {
            $desc .= '</div>';
          }
          $contents['booking_details'][$item->cart_item_id] = array(
            '#type' => 'fieldset',
            '#title' => $title,
            '#description' => $desc,
            '#collapsible' => TRUE,
            // Default to collapsed if there are multiple room booking items in the cart,
            // or the booking has more than three nights and more than two addons, or if
            // the a single booking item has more than 5 nights.
            '#collapsed' => (sizeof($numnights) > 1 || ($numnights[$item->cart_item_id] > 3 && sizeof($item->data['booking_upgrades']) > 2) || ($numnights[$item->cart_item_id] > 5)) ? TRUE : FALSE,
          );
          $val = hotel_booking_cart_details_table($item);
          $contents['booking_details'][$item->cart_item_id]['nid'] = array(
            '#value' => $val[0],
          );
          if ($val[1]) {
            $contents['booking_details'][$item->cart_item_id]['nid']['additional'] = array(
              '#value' => hotel_booking_cart_details_table($item, TRUE),
            );
          }
        }
      }
      return array('contents' => $contents);
  }
}

function hotel_booking_cart_details_table(&$item, $additional = FALSE) {
  $addons = array();
  if ($item->data['booking_upgrades']) {
    foreach($item->data['booking_upgrades'] as $nid => $cart_item_id) {
      $addons[$nid]['cart'] = db_fetch_array(db_query('SELECT * FROM {uc_cart_products} WHERE cart_item_id = %d', $cart_item_id));
      $addons[$nid]['data'] = unserialize($addons[$nid]['cart']['data']);
      $addons[$nid]['daily'] = ($addons[$nid]['data']['days']) ? TRUE : FALSE;
      if (!$additional_items) {
        $additional_items = (!$addons[$nid]['daily']) ? TRUE : FALSE;
      }
      if (!$daily_items) {
        $daily_items = ($addons[$nid]['daily']) ? TRUE : FALSE;
      }

      // For the first time running through this function ($additional = FALSE)
      // If the item is not a daily addon item, we just won't pay it any mind.
      if (!$additional && $addons[$nid]['daily']) {
        $addons[$nid]['node'] = node_load($nid);
      }

      // If we're coming around a second time for non-daily items don't do
      // a node load on those daily items.
      elseif ($additional && !$addons[$nid]['daily']) {
        $addons[$nid]['node'] = node_load($nid);
      }
    }
  }
  if (!$additional) {
    if ($addons && $daily_items) {
      $addon_title = t('Date Based Add-On Items');
      $qtys = t('Qty.');
    }
    $header = array(t('Dates'), array('data' => $addon_title, 'width' => '45%'), array('data' => t(''), 'colspan' => 2), $qtys, t('Total'));
    for ($i = 0; $i < sizeof($item->data['nights']); $i++) {
      $checkin = ($i == 0) ? t('Check-In') : '';
      $thisday = $item->data['nights'][$i];
      $foo = explode('-', $thisday);
      $today = date('l F j, Y', mktime(0, 0, 0, $foo[1], $foo[2], $foo[0]));
      $rows[] = array($today, '',  t('Night !night', array('!night' => ($i + 1))), $checkin, '', array('data' => '$'. $item->data['prices'][$i], 'class' => 'price'));
      foreach ($addons as $nid => $info) {
        if ($addons[$nid]['daily'] && $addons[$nid]['data']['days'][$thisday]) {
          $rows[] = array('', l($addons[$nid]['node']->title, 'booking_upgrades/'. $addons[$nid]['data']['parent_id']),'','',array('data' => $addons[$nid]['data']['days'][$thisday], 'class' => 'qty'), array('data' => '$' . number_format(($addons[$nid]['data']['days'][$thisday] * $addons[$nid]['node']->sell_price), 2, '.', ','), 'class' => 'price'));
        }
      }
    }
    $thisday = date('Y-m-d', mktime(0, 0, 0, $foo[1], $foo[2]+1, $foo[0]));
    $today = date('l F j, Y', mktime(0, 0, 0, $foo[1], $foo[2]+1, $foo[0]));
    $rows[] = array($today, '', '', t('Check-Out'), '', '');
    foreach ($addons as $nid => $info) {
      if ($addons[$nid]['daily'] && $addons[$nid]['data']['days'][$thisday]) {
        $rows[] = array('', l($addons[$nid]['node']->title, 'booking_upgrades/'. $addons[$nid]['data']['parent_id']),'','',array('data' => $addons[$nid]['data']['days'][$thisday], 'class' => 'qty'), array('data' => '$' . number_format(($addons[$nid]['data']['days'][$thisday] * $addons[$nid]['node']->sell_price), 2, '.', ','), 'class' => 'price'));
      }
    }

    $table = theme('table', $header, $rows);
    if ($additional_items) {
    }
    return array($table, $additional_items);
  }
  else {
    $header = array(array('data' => t('Additional Add-On & Upgrade Items'), 'colspan' => 2, 'width' => '100%'), 'data' => t('Total'));
    foreach ($addons as $nid => $info) {
      if (!$addons[$nid]['daily']) {
        $rows[] = array($addons[$nid]['cart']['qty'] .'x', array('data' => l($addons[$nid]['node']->title, 'booking_upgrades/'. $addons[$nid]['data']['parent_id']), 'width' => '100%'), array('data' => '$' . number_format(($addons[$nid]['cart']['qty'] * $addons[$nid]['node']->sell_price), 2, '.', ','), 'class' => 'price'));
      }
    }
    return theme('table', $header, $rows);
  }
}
